package net.zmobile.ui;

import java.util.Vector;

import javax.microedition.lcdui.Graphics;

import net.zmobile.ge.ZPoint;
import net.zmobile.ge.ZRect;
import net.zmobile.ui.layout.ZLayout;

public class ZContainer extends ZComponent {
	Vector _components = new Vector();
	ZLayout _lManger = null;

	int translateX = 0;
	int translateY = 0;

	int _client_w = 0;
	int _client_h = 0;

	int _client_x = 0;
	int _client_y = 0;

	public void add(ZComponent comp) {
		_components.addElement(comp);
		resize();
	}

	public void remove(ZComponent comp) {
		_components.removeElement(comp);
		resize();
	}

	public void setLayout(ZLayout lManger) {
		_lManger = lManger;
		resize();
	}

	public void resize() {
		resizeClientBounds();
		System.out.println(_client_x + ":" + _client_y + ":" + _client_w + ":"
				+ _client_h);
		if (_lManger != null) {
			_lManger.resize(new ZRect(_client_x, _client_y, _client_w,
					_client_h), _components);
		}
	}

	public void firePointRelease(ZPoint point) {
		super.firePointRelease(point);
//		ZRect rect = new ZRect(_x, _y, _w, _h);
		for (int i = 0; i < _components.size(); i++) {
			Object comp = _components.elementAt(i);
			((ZComponent) comp).firePointRelease(point);
		}

	}

	public void firePointPressed(ZPoint point) {
		super.firePointRelease(point);
//		ZRect rect = new ZRect(_x, _y, _w, _h);
		for (int i = 0; i < _components.size(); i++) {
			Object comp = _components.elementAt(i);
			((ZComponent) comp).firePointPressed(point);
		}

	}

	public void fireSelectedRelease() {
		super.fireSelectedRelease();
		for (int i = 0; i < _components.size(); i++) {
			Object comp = _components.elementAt(i);
			((ZComponent) comp).fireSelectedRelease();
		}

	}

	public void fireSelectedPressed() {
		super.fireSelectedPressed();

		for (int i = 0; i < _components.size(); i++) {
			Object comp = _components.elementAt(i);
			((ZComponent) comp).fireSelectedPressed();
		}

	}

	public void draw(Graphics g) {
		g.setColor(0x0000ff);
		for (int i = 0; i < _components.size(); i++) {
			Object comp = _components.elementAt(i);
			((ZComponent) comp).redraw(g);
		}
	}

	public void setFoucus(boolean foucus) {
		super.setFoucus(foucus);
		int times = 0;
		for (int i = 0; i < _components.size(); i++) {
			ZComponent comp = (ZComponent) _components.elementAt(i);
			if (!comp.isCanFoucus() && times == 0) {
				comp.setFoucus(foucus);
				times++;
			} else {
				comp.setFoucus(false);
			}
		}
	}

	public void nextFoucus() {

	}

	public void drawStatus(Graphics g) {

	}

	public int getClientWidth() {
		return _client_w;
	}

	public int getClientHeight() {
		return _client_h;
	}

	public int getClientX() {
		return _client_x;
	}

	public int getClientY() {
		return _client_y;
	}

	public void setBounds(int x, int y, int w, int h) {
		super.setBounds(x, y, w, h);
		resizeClientBounds();
	}

	protected void resizeClientBounds() {
		this._client_x = _x;
		this._client_y = _y;
		this._client_w = _w;
		this._client_h = _h;
	}

	public void resetSize() {

	}
}
